﻿//Controls overall game flow
//Main game code starts after initalAniFinishedClickToPlay() is executed from the intialAniBUtton

class GameController extends MovieClip{
	
	//************************************************************
	//PRIVATE VARS
	//************************************************************
	
	//initial animation
	private var InitialAni:MovieClip;
	//Animation between questions, also contains the question number
	private var InterAni:MovieClip;
	private var IncorrectAni:MovieClip;
	private var CorrectAni:MovieClip;
	private var Questions:MovieClip;
	private var ProgressControl:MovieClip;
	private var Results:MovieClip;
	private var BubblesMC:MovieClip;
	private var thisUserProgress:UserProgress;
	
	
	
	
	//************************************************************
	//PROPERTIES
	//************************************************************
	
	
	
	
	//************************************************************
	//CONSTRUCTOR FUNCTIONS
	//************************************************************
	
	
	
	public function GameController(){
		
		trace("GameController created");
		//connect the MCs (This could be changed to Dispatched Events)
		
		//Questions = _root.Questions;
		Questions = _root.emptyClip.Questions;
		visual_initialVisualSetup();
	
		//Note game is set off when the user click a button in 
		//InitialAni and executes initalAniFinishedClickToPlay(); 
		
	}
	
	
	
	
	
	//************************************************************
	//VISUAL FUNCTIONS
	//************************************************************
	private function visual_initialVisualSetup(){
		
		_root.emptyClip.tempFix._visible = false;
		
		InitialAni._x = 315;
		InitialAni._y = 240;
		InitialAni._visible = true;
		
		InterAni._x = 317.5;
		InterAni._y = 240;
		InterAni._visible = false;
		
		CorrectAni._x = 0;
		CorrectAni._y = 0;
		CorrectAni._alpha = 0;
		
		IncorrectAni._x = 0;
		IncorrectAni._y = 0;
		IncorrectAni._alpha = 0;
		
		ProgressControl._visible = false;
		ProgressControl.NextButton.enabled = false;
		ProgressControl.NextButton._alpha = 30;
		ProgressControl.ProgressText._alpha = 30;
		trace(ProgressControl.ProgressText);
		
		Results._x = 0;
		Results._y = 0;
		Results._visible = false;
		
		Questions._visible = false;
		
		
	}
	
	
	
	
	private function visual_userClicksAnswer(){
		
		ProgressControl._visible = false;
		ProgressControl.NextButton.enabled = true;
		ProgressControl.NextButton._alpha = 100;
		ProgressControl.btnNextFlash.gotoAndPlay("start");
		ProgressControl.ProgressText._alpha = 100;
		Questions._visible = false;
		
		
	}
	
	
	
	//This happens when a user clicks next question
	private function visual_interAniStarted(){
		
		Questions._visible = false;
		InterAni.tween("_alpha",100,1,"customEasing");
		
	}
	
	
	
	//runs when the animation between questions is finished
	private function visual_interAniFinished(){
		
		//put in a fade transition
		InterAni.tween("_alpha",0,1,"customEasing");
		
		// turn off the init ani otherwise it's button can still be rolled over
		InitialAni._visible = false;
		
		ProgressControl._visible = true;
		Questions._visible = true;
		
	}
	
	
	
	private function visual_userClicksShowResults(){
		
		_root.emptyClip.tempFix._visible = true;
		
		Results._visible = true;
		Results._alpha = 0;
		Questions.tween("_alpha",0,1,"customEasing");
		Results.tween("_alpha",100,1,"customEasing");
		
		ProgressControl.NextBtn._visible = false;
		ProgressControl.btnText._visible = false;
		
		
		
		Results.sound.gotoAndPlay(2);
		
	}
	
	
	//runs when the question response mc is needed, responseMC is Questions.as
	private function visual_answerResponseMCNeeded(){
		
		ProgressControl._visible = true;
		Questions._visible = true;
		
	}
	
	
	//runs when the user clicks to play
	private function visual_userClicksToPlay(){
	
		BubblesMC = _root.emptyClip.BubblesMC;
		trace("****** = " + BubblesMC);
		BubblesMC.startBubbles();
		
		//Hide the InitAni
		InitialAni.tween("_alpha",0,1,"customEasing");
		InterAni._visible = true;
		
	}
	
	
	
	
	//************************************************************
	//GENERAL FUNCTIONS
	//************************************************************
	
	
	
	//Tells the InterAni to play between questions
	private function playInterAni(){
		
		visual_interAniStarted();
		ProgressControl.btnNextFlash.gotoAndPlay(1);
		
		//update the question number in the interAni MC
		InterAni.questionNumber.text = thisUserProgress.question;
		InterAni.gotoAndPlay(2);
		InterAni.interQuestionTitle.Qtitle.gotoAndStop("q" + thisUserProgress.question);
		
	}
	
	
	//Tells the Question MC to goto next question
	private function playTheNextQuestion(){
		
		visual_interAniFinished();
		Questions.playQuestion(thisUserProgress.question);
		
	}
	
	
	
	//Plays the correct or incorrect ani, called from Questions.as
	public function playTheCorrectIncorrectAni(correct:Boolean, questionNum:Number){
		
		//do a visual tidy
		visual_userClicksAnswer();
		
		//Update the UserProgress
		thisUserProgress.QuestionAnswer(correct, questionNum);
		
		//Play the correct or incorrect ani
		if(correct){
			
			//CorrectAni._visible = true;
			CorrectAni.tween("_alpha",100,1,"customEasing");
			CorrectAni.gotoAndPlay(2);
			
		}else{
			
			//IncorrectAni._visible = true;
			IncorrectAni.tween("_alpha",100,1,"customEasing");
			IncorrectAni.gotoAndPlay(2);
			
		}
	}
	
	
	//Plays the results movieclip for the user.
	private function playResults(){
	
		Results.gotoAndStop("r" +  thisUserProgress.score);
		visual_userClicksShowResults();
	
	}
	
	
	
	
	//************************************************************
	//EVENT FUNCTIONS
	//************************************************************
	
	
	//Starts the game after the initial, executed from the intialAniBUtton
	private function initalAniFinishedClickToPlay(){
		
		InitialAni.gotoAndStop("stop");
		
		//create the userProgress storage class
		thisUserProgress = new UserProgress();
		
		//update the question number in the interAni MC
		visual_userClicksToPlay();
		InterAni.interQuestionTitle.Qtitle.gotoAndStop("q" + thisUserProgress.question);
		
		//Start the question cycle process
		InterAni.gotoAndPlay(2);
		
		
	}
	
	
	//Runs at the start and between all questions
	//Asks the GameController which question to play next
	private function interAniFinished(){
		
		playTheNextQuestion();
		
	}
	
	
	//Asks the GameController to display the correct question response
	private function correctAniFinishedClickForCorrectResponse(){
		
		trace("Question number = " + thisUserProgress.question);
		
		//check for last question to change ProgressControl's button text to Results
		//Res1_1, Res1_2, Res1_3, Res2_1, Res2_2, Res2_3,  etc
		if(thisUserProgress.question == 6){ProgressControl.ProgressText.gotoAndStop("show");}

		
		visual_answerResponseMCNeeded();
		Questions.gotoAndStop("Res" + (thisUserProgress.question -1) + "_" + thisUserProgress.questionNum);
		//CorrectAni._visible = false;
		CorrectAni.tween("_alpha",0,1,"customEasing");
		
		
		
		
	}
	
	
		//Asks the GameController to display the incorrect question response
	private function inCorrectAniFinishedClickForCorrectResponse(){
		
		trace("Question number = " + thisUserProgress.question);
		
		//check for last question to change ProgressControl's button text to Results
		if(thisUserProgress.question == 6){ProgressControl.ProgressText.gotoAndStop("show");}
		
		visual_answerResponseMCNeeded();
		//Res1_1, Res1_2, Res1_3, Res2_1, Res2_2, Res2_3,  etc
		Questions.gotoAndStop("Res" + (thisUserProgress.question -1) + "_" + thisUserProgress.questionNum);
		//IncorrectAni._visible = false;
		IncorrectAni.tween("_alpha",0,1,"customEasing");
		
		
		
	}
	
	
	
}